var User = {
	'is_login': false,
	'login': false,
	'mac': false,
	'duid': false,
	'device': false,
	'tv': false,
	'params': {},
	'networkPlugin': false,
	'license_confirm': false
};

User.init = function() {
	var NNaviPlugin = document.getElementById('pluginNnavi');
	User.tv = document.getElementById('pluginTV');
	User.parseParams(window.location.search);
	
	addLog(window.location.search);
	addLog("User.params.country="+User.params.country);
	
	User.mac = User.networkPlugin.GetMAC(1);
	User.duid = rc4_encode(NNaviPlugin.GetDUID(User.mac));
	User.isActiveDevice();
};

User.parseParams = function(params) {
	var params_arr = params.split('&');
	jQuery.each(params_arr, function(index, value) {
		var single_param_arr = value.split('=');		
		User.params[single_param_arr[0].replace("?", "")] = single_param_arr[1];
	});
	User.params.product = User.tv.GetProductType();
	if (!User.params.country) User.params.country = 'ru';
	User.params.country = 'ru';
};

User.isActiveDevice = function() {
	Navigator.jsonp('isActiveDevice', false, false, true);
};

User.CheckUser = function() {
	Navigator.jsonp('checkUser', false, false, true);
};

User.checkNetwork = function() {
	var status = User.networkPlugin.GetActiveType();
	if (status < 0 && APP_STATE != STATE_DISCONNECTED) {
		Config.state_before = APP_STATE;
		APP_STATE = STATE_DISCONNECTED;
		Player.stopVideo();
		if (Config.loaded_index) {
			jQuery('#main').append('<div id="modalwrapper"></div><div id="modal" style="height: 250px;"><h1>Сеть не доступна. Подключите сетевой кабель.</h1><p><img style="margin-right: 10px;" src="app/resources/360.gif"></p></div>');
		} else {
			widgetAPI.sendExitEvent();
		};
	};
	if (status > 0 && APP_STATE == STATE_DISCONNECTED) {
		jQuery('#modalwrapper, #modal').remove();
		APP_STATE = STATE_NORMAL;
		var element = jQuery('.full_screen');
		element.html(element.attr('max'));
	};
};