var FileSys = new FileSystem();

if (FileSys.isValidCommonPath(curWidget.id) == 0 || FileSys.isValidCommonPath(curWidget.id) == 2) {
	FileSys.createCommonDir(curWidget.id);
}

FileSys.checkFile = function(file, rules) {
	if (rules == undefined) rules = 'r+';
	var fileObj = FileSys.openCommonFile(curWidget.id + '/' + file, rules);
	if (fileObj && fileObj !== undefined) {
		return fileObj;
	} else {		
		return false;
	}
};

FileSys.readFromFile = function(file) {
	var fileObj = FileSys.checkFile(file);
	if (fileObj) {
		var content = fileObj.readAll();
		FileSys.closeCommonFile(fileObj);
		return content;
	}
};

FileSys.writeToFile = function(file, content) {
	if (content == undefined) return;
	var fileObj = FileSys.checkFile(file, 'w+');
	if (fileObj) {
		fileObj.writeAll(content);
		FileSys.closeCommonFile(fileObj);
		return true;
	}
};

FileSys.deleteFile = function(file) {
	var bResult = FileSys.deleteCommonFile(curWidget.id + '/' + file);
	alert(bResult);
	if (bResult) return true;
	return false;
};
